#!/bin/sh
## this is a bash script
## perhaps it works with other shells too but no warranty

## Written by Michael Bell for the OpenCA project 2004
## (c) Copyright 2004 The OpenCA Project. All rights reserved.
## Modified by Massimiliano Pala <madwolf@openca.org>

set -e

prefix=/opt/openca
exec_prefix=/opt/openca
cf_mod=`stat -c %Y /opt/openca/etc/openca/config.xml`

# /bin/touch "/opt/openca/etc/openca/config.xml"

for DIRECTORY in /opt/openca/etc/openca /opt/openca/lib/openca /opt/openca/var/www/html/pki/ca /opt/openca/var/www/html/pki/ra /opt/openca/var/www/html/pki/node /opt/openca/var/www/html/pki/ldap /opt/openca/var/www/html/pki/pub /opt/openca/var/www/html/pki/batch /opt/openca/etc/openca/servers /opt/openca/etc/openca/agreements /opt/openca/etc/openca/menus


do
    if test -d $DIRECTORY; then
        echo =================================================================
        echo fixing directory: $DIRECTORY
        echo =================================================================

        cd $DIRECTORY
        TEMPLATES=`find . -name "*.template" -print`
        for H in $TEMPLATES
        do
	    template_mod=`stat -c %Y $H`

            echo -------------begin file-----------------
            echo template: $H
            H_RESULT=`echo $H | sed 's/\.template//'`
            echo target:   $H_RESULT

	    if ! [ -f "$H_RESULT" ] ; then 
		temp_mod=0
	    else
	    	temp_mod=`stat -c %Y $H_RESULT`
	    fi

	    UPDATE=0

	    if [ $template_mod -ge $temp_mod ] ; then
		UPDATE=1
	    else
		if [ $cf_mod -ge $temp_mod ] ; then
			UPDATE=2
		fi
	    fi

	    echo "UPDATE => $UPDATE"
            if [ $UPDATE -gt 0 ] ; then
                echo status:   To be updated
            	${exec_prefix}/bin/openca-configure /opt/openca/etc/openca/config.xml $H $H_RESULT
            else
                echo status:   Updated
            fi
            echo --------------end file------------------
        done
    fi
done

# By this moment configure_etc.sh has successfully inserted the value of
# option cert_chars from config.xml into utf8_latin1_selector.sh 
# and we can call the latter from here, performing an effective reqursion:

/opt/openca/etc/openca/utf8_latin1_selector.sh

# Now we translate the menus

${exec_prefix}/bin/openca-menu-translate

exit 0;

